/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.35
        Device            :  PIC16F1778
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set S1 aliases
#define S1_TRIS               TRISAbits.TRISA2
#define S1_LAT                LATAbits.LATA2
#define S1_PORT               PORTAbits.RA2
#define S1_WPU                WPUAbits.WPUA2
#define S1_OD                ODCONAbits.ODA2
#define S1_ANS                ANSELAbits.ANSA2
#define S1_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define S1_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define S1_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define S1_GetValue()           PORTAbits.RA2
#define S1_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define S1_SetPullup()      do { WPUAbits.WPUA2 = 1; } while(0)
#define S1_ResetPullup()    do { WPUAbits.WPUA2 = 0; } while(0)
#define S1_SetPushPull()    do { ODCONAbits.ODA2 = 0; } while(0)
#define S1_SetOpenDrain()   do { ODCONAbits.ODA2 = 1; } while(0)
#define S1_SetAnalogMode()  do { ANSELAbits.ANSA2 = 1; } while(0)
#define S1_SetDigitalMode() do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set S2 aliases
#define S2_TRIS               TRISAbits.TRISA3
#define S2_LAT                LATAbits.LATA3
#define S2_PORT               PORTAbits.RA3
#define S2_WPU                WPUAbits.WPUA3
#define S2_OD                ODCONAbits.ODA3
#define S2_ANS                ANSELAbits.ANSA3
#define S2_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define S2_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define S2_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define S2_GetValue()           PORTAbits.RA3
#define S2_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define S2_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define S2_SetPullup()      do { WPUAbits.WPUA3 = 1; } while(0)
#define S2_ResetPullup()    do { WPUAbits.WPUA3 = 0; } while(0)
#define S2_SetPushPull()    do { ODCONAbits.ODA3 = 0; } while(0)
#define S2_SetOpenDrain()   do { ODCONAbits.ODA3 = 1; } while(0)
#define S2_SetAnalogMode()  do { ANSELAbits.ANSA3 = 1; } while(0)
#define S2_SetDigitalMode() do { ANSELAbits.ANSA3 = 0; } while(0)

// get/set Red aliases
#define Red_TRIS               TRISBbits.TRISB2
#define Red_LAT                LATBbits.LATB2
#define Red_PORT               PORTBbits.RB2
#define Red_WPU                WPUBbits.WPUB2
#define Red_ANS                ANSELBbits.ANSB2
#define Red_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define Red_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define Red_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define Red_GetValue()           PORTBbits.RB2
#define Red_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define Red_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define Red_SetPullup()      do { WPUBbits.WPUB2 = 1; } while(0)
#define Red_ResetPullup()    do { WPUBbits.WPUB2 = 0; } while(0)
#define Red_SetAnalogMode()  do { ANSELBbits.ANSB2 = 1; } while(0)
#define Red_SetDigitalMode() do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set SCL aliases
#define SCL_TRIS               TRISCbits.TRISC3
#define SCL_LAT                LATCbits.LATC3
#define SCL_PORT               PORTCbits.RC3
#define SCL_WPU                WPUCbits.WPUC3
#define SCL_OD                ODCONCbits.ODC3
#define SCL_ANS                ANSELCbits.ANSC3
#define SCL_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define SCL_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define SCL_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define SCL_GetValue()           PORTCbits.RC3
#define SCL_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define SCL_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define SCL_SetPullup()      do { WPUCbits.WPUC3 = 1; } while(0)
#define SCL_ResetPullup()    do { WPUCbits.WPUC3 = 0; } while(0)
#define SCL_SetPushPull()    do { ODCONCbits.ODC3 = 0; } while(0)
#define SCL_SetOpenDrain()   do { ODCONCbits.ODC3 = 1; } while(0)
#define SCL_SetAnalogMode()  do { ANSELCbits.ANSC3 = 1; } while(0)
#define SCL_SetDigitalMode() do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set SDA aliases
#define SDA_TRIS               TRISCbits.TRISC4
#define SDA_LAT                LATCbits.LATC4
#define SDA_PORT               PORTCbits.RC4
#define SDA_WPU                WPUCbits.WPUC4
#define SDA_OD                ODCONCbits.ODC4
#define SDA_ANS                ANSELCbits.ANSC4
#define SDA_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define SDA_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define SDA_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define SDA_GetValue()           PORTCbits.RC4
#define SDA_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define SDA_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define SDA_SetPullup()      do { WPUCbits.WPUC4 = 1; } while(0)
#define SDA_ResetPullup()    do { WPUCbits.WPUC4 = 0; } while(0)
#define SDA_SetPushPull()    do { ODCONCbits.ODC4 = 0; } while(0)
#define SDA_SetOpenDrain()   do { ODCONCbits.ODC4 = 1; } while(0)
#define SDA_SetAnalogMode()  do { ANSELCbits.ANSC4 = 1; } while(0)
#define SDA_SetDigitalMode() do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set LCDPWR aliases
#define LCDPWR_TRIS               TRISCbits.TRISC5
#define LCDPWR_LAT                LATCbits.LATC5
#define LCDPWR_PORT               PORTCbits.RC5
#define LCDPWR_WPU                WPUCbits.WPUC5
#define LCDPWR_OD                ODCONCbits.ODC5
#define LCDPWR_ANS                ANSELCbits.ANSC5
#define LCDPWR_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define LCDPWR_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define LCDPWR_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define LCDPWR_GetValue()           PORTCbits.RC5
#define LCDPWR_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define LCDPWR_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define LCDPWR_SetPullup()      do { WPUCbits.WPUC5 = 1; } while(0)
#define LCDPWR_ResetPullup()    do { WPUCbits.WPUC5 = 0; } while(0)
#define LCDPWR_SetPushPull()    do { ODCONCbits.ODC5 = 0; } while(0)
#define LCDPWR_SetOpenDrain()   do { ODCONCbits.ODC5 = 1; } while(0)
#define LCDPWR_SetAnalogMode()  do { ANSELCbits.ANSC5 = 1; } while(0)
#define LCDPWR_SetDigitalMode() do { ANSELCbits.ANSC5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()    do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()   do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()   do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()         PORTCbits.RC6
#define RC6_SetDigitalInput()   do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()  do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()     do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()   do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode() do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()    do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()   do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()   do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()         PORTCbits.RC7
#define RC7_SetDigitalInput()   do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()  do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()     do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()   do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode() do { ANSELCbits.ANSC7 = 1; } while(0)
#define RC7_SetDigitalMode()do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/